import 'dart:convert';
import 'package:convert/convert.dart';
import "package:pointycastle/digests/md5.dart";
import "package:pointycastle/digests/sha1.dart";
import "package:pointycastle/digests/sha256.dart";
import "package:pointycastle/digests/sha512.dart";

class CryptoUtil {
  static String base64Encode2Str(String data) => base64Encode(utf8.encode(data));

  static String base64Decode2Str(String data) => String.fromCharCodes(base64Decode(data));

  static String hexEncode2Str(String data) => hex.encode(utf8.encode(data));

  static String hexDecode2Str(String data) => String.fromCharCodes(hex.decode(data));

  static String md5(String data, {String salt = ''}) {
    return hex.encode(MD5Digest().process(utf8.encode('$data$salt')));
  }

  static String sha1(String data, {String salt = ''}) {
    return hex.encode(SHA1Digest().process(utf8.encode('$data$salt')));
  }

  static String sha256(String data, {String salt = ''}) {
    return hex.encode(SHA256Digest().process(utf8.encode('$data$salt')));
  }

  static String sha512(String data, {String salt = ''}) {
    return hex.encode(SHA512Digest().process(utf8.encode('$data$salt')));
  }
}
