class DateUtil {
  ///获取当前时间的DateTime
  static DateTime currentTime = DateTime.now();

  ///获取当前时间的int值
  static int milliSeconds = currentTime.millisecondsSinceEpoch;

  ///根据毫秒数获取DateTime
  static DateTime parseInt(int milliSeconds) {
    return DateTime.fromMillisecondsSinceEpoch(milliSeconds);
  }

  ///返回日期是星期几,默认返回数字,ch为true时返回中文
  static dynamic dayOfWeek(DateTime datetime, {bool ch = false}) {
    var chs = ['一', '二', '三', '四', '五', '六', '日'];
    if (ch) {
      return chs[datetime.weekday - 1];
    }
    return datetime.weekday;
  }

  ///根据字符串获取DateTime
  static DateTime parseStr(String str) => DateTime.parse(str);

  ///根据format格式化milliSeconds,默认format为yyyy-MM-dd HH:mm:ss.SSS
  static String formatMicroseconds(int milliSeconds, {String format = 'yyyy-MM-dd HH:mm:ss'}) {
    return formatDateTime(parseInt(milliSeconds), format: format);
  }

  ///根据format格式化DateTime,默认format为yyyy-MM-dd HH:mm:ss.
  static String formatDateTime(DateTime datetime, {String format = 'yyyy-MM-dd HH:mm:ss'}) {
    String formatStr = format;
    //year
    formatStr = _replace(formatStr, format, 'y', datetime.year);
    //month
    formatStr = _replace(formatStr, format, 'M', datetime.month);
    //day
    formatStr = _replace(formatStr, format, 'd', datetime.day);
    //hour
    formatStr = _replace(formatStr, format, 'H', datetime.hour);
    //minute
    formatStr = _replace(formatStr, format, 'm', datetime.minute);
    //second
    formatStr = _replace(formatStr, format, 's', datetime.second);
    //milliSeconds
    formatStr = _replace(formatStr, format, 'S', datetime.millisecond);

    return formatStr;
  }

  static String _replace(String formatStr, String format, String char, int date) {
    int num = 0;
    format.split('').forEach((str) {
      if (str == char) num++;
    });
    var replace;
    if (num > 0) {
      switch (char) {
        case 'y':
          replace = num == 2 ? '$date'.substring(2, 4) : '$date';
          break;
        case 'S':
          replace = '$date';
          break;
        default:
          replace = num == 1 ? '$date' : date < 10 ? '0$date' : '$date';
          break;
      }
    }
    if (replace != null) formatStr = formatStr.replaceAll(char * num, replace);
    return formatStr;
  }
}
